package comp3804a3;

public class LessPathfinder {

    public int minMoves(int n, boolean[][] leftWall, boolean[][] bottomWall) {
        return 0;
    }

    public static void main(String[] args) {
        // Board from the assignment
        int n = 4;
        boolean[][] leftWall = new boolean[][]{
            new boolean[]{false, false, false, false}, // first column
            new boolean[]{true, true, false, true}, // second column
            new boolean[]{false, true, true, true}, // third column
            new boolean[]{false, false, false, false}, // last column
        };
        boolean[][] bottomWall = new boolean[][]{
            new boolean[]{false, false, false, false},
            new boolean[]{false, false, false, false},
            new boolean[]{false, false, false, false},
            new boolean[]{false, true, false, false},};

        System.out.print("Checking basic correctness... ");
        LessPathfinder lpf = new LessPathfinder();
        if (lpf.minMoves(n, leftWall, bottomWall) != 7) {
            System.out.println("Number of moves is " + lpf.minMoves(n, leftWall, bottomWall) + ", but should be 7.");
        } else {
            System.out.println("Looks okay so far.");
        }

        System.out.println("Testing basic efficiency: this should take less than a second...");
        long start = System.currentTimeMillis();

        n = 100;
        int it = 8;

        for (int i = 0; i < it; i++) {
            leftWall = new boolean[n][n];
            bottomWall = new boolean[n][n];

            for (int j = 0; j < n; j++) {
                for (int k = 0; k < n; k++) {
                    leftWall[j][k] = (i + (j % 5 + k % 7)) % 3 != 0;
                    bottomWall[j][k] = (i + (j % 3 - k % 5)) % 3 != 0;
                }
            }

            for (int j = 0; j < it; j++) {
                lpf.minMoves(n, leftWall, bottomWall);
            }
        }

        System.out.println("Done. That took " + ((System.currentTimeMillis() - start) / 1000.0) + " seconds.");
    }
}
